<script setup>
  import { TransitionRoot } from '@headlessui/vue';

  const { dynamicCmsPages, loading, requestCloseSpecificDynamicPage } = useDynamicPage();
  const styling = reactive({ left: '0px', width: '100%' });
  const { isSelfService } = useAppointment();
  const { isGuide } = useUser();
  const cmsContainer = ref(null);
  const { width, height } = useElementSize(cmsContainer);

  onMounted(() => {
    cmsContainer.value = document.querySelector('#cms-container');
    calculateOffsets();
  });

  const isShown = computed(() => loading.value || dynamicCmsPages.value.length > 0);

  const calculateOffsets = () => {
    if (cmsContainer.value) {
      const rect = cmsContainer.value.getBoundingClientRect();
      styling.left = `${rect.left}px`;
      styling.width = `${rect.width}px`;
    }
  };

  watch([isShown, width, height], () => {
    if (isShown.value) {
      calculateOffsets();
    }
  });
</script>
<template>
  <TransitionRoot
    :show="isShown"
    enter-active-class="transition ease-out duration-200 transform"
    enter-from-class="opacity-0"
    enter-to-class="opacity-100"
    leave-active-class="transition ease-in duration-300 transform"
    leave-from-class="opacity-100"
    leave-to-class="opacity-0"
  >
    <div class="fixed bottom-0 top-0 z-10 bg-white" :style="styling">
      <SwLoading v-if="loading" class="text-primary z-loading absolute inset-0 bg-white text-3xl" />
      <div
        v-for="(dynamicCmsPage, index) of dynamicCmsPages"
        :key="index"
        class="md:(pt-10 pb-26) lg:(pt-10 pb-28) absolute inset-0 overflow-auto bg-white px-5 pb-20 pt-4"
        :style="{
          zIndex: 1 + index,
        }"
      >
        <div
          v-if="isGuide || isSelfService"
          class="3xl:max-w-screen-2xl mx-auto mb-6 max-w-screen-xl"
        >
          <SwBackButton @click="() => requestCloseSpecificDynamicPage(dynamicCmsPage)" />
        </div>
        <CmsPage
          v-if="dynamicCmsPage?.cms?.cmsPage"
          :key="dynamicCmsPage?.cms?.cmsPage"
          :content="dynamicCmsPage?.cms?.cmsPage"
          :options="dynamicCmsPage?.cms"
          type="presentation"
        />
        <Component :is="dynamicCmsPage?.static" v-else-if="dynamicCmsPage?.static" />
      </div>
    </div>
  </TransitionRoot>
</template>
